#ifndef ENTITY_H
#define ENTITY_H

#include <SFML/System/NonCopyable.hpp>
#include <SFML/System/Time.hpp>
#include <SFML/Graphics/Sprite.hpp>

#include <Category.h>
#include <ResourceIdentifiers.h>

class Entity : public sf::Sprite, private sf::NonCopyable
{


public:
								Entity(const TextureHolder &textures, Textures id, Category category, float x, float y, float angle);
	void					update(sf::Time elapsedTime, int maxX, int maxY);

	int						getSpeedFactor();
	void					speedFactor(int relativeSpeedFactor);
	int						getWheelsTurn();
	void					wheelsTurn(int relativeWheelsTurn);

private:
	Category				mCategory;
	int						mSpeedFactor;
	int						mWheelsTurn;
};

#endif // ENTITY_H
