#ifndef GAME_H
#define GAME_H

#include <SFML/Graphics.hpp>
#include <vector>
#include <map>
#include <memory>

#include <ResourceIdentifiers.h>
#include <Entity.h>

class Game : private sf::NonCopyable
{
	public:
								Game();
		void					run();

	public:
		static const int		Width;
		static const int		Height;

	private:
		void					processEvents();
		void					update(sf::Time elapsedTime);
		void					render();

		void					updateStatistics(sf::Time elapsedTime);	
		void					handlePlayerInput(int playerNum, sf::Keyboard::Key key);
		

	private:
		static const sf::Time	TimePerFrame;

		sf::RenderWindow		mWindow;
		TextureHolder			mTextures;
		FontHolder				mFonts;

		std::vector<std::unique_ptr<Entity>> mEntities;
		int						mPlayerNum;

		sf::Text				mStatisticsText;
		sf::Time				mStatisticsUpdateTime;

		std::size_t				mStatisticsNumFrames;
		bool					mIsMovingUp;
		bool					mIsMovingDown;
		bool					mIsMovingRight;
		bool					mIsMovingLeft;
};

#endif // GAME_H
