#ifndef RESOURCEIDENTIFIERS_H
#define RESOURCEIDENTIFIERS_H

#include <ResourceHolder.h>
#include <SFML/Graphics/Texture.hpp>
#include <SFML/Graphics/Font.hpp>

// Forward declaration of SFML classes
namespace sf
{
	class Texture;
	class Font;
}

enum class Textures
{
	BlueCar,
	GreenCar,
	RedCar,
	YellowCar,
};

enum class Fonts
{
	Main,
};

// Forward declaration and a few type definitions
template <typename Resource, typename Identifier>
class ResourceHolder;

typedef ResourceHolder<sf::Texture, Textures>			TextureHolder;
typedef ResourceHolder<sf::Font, Fonts>					FontHolder;

#endif // RESOURCEIDENTIFIERS_H
